package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLBasicSet_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLBasicSet extends JNIObject implements IISLSingleSpaceSetMethods, IISLProjectionMethods {
	
	/* @generated */
	protected ISLBasicSet(long ptr) {
		/*** PROTECTED REGION ID(ISLBasicSet_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLBasicSet build(long ptr) {
		return new ISLBasicSet(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLBasicSet_userCode) ENABLED START ***/
	public String toString(ISL_FORMAT format) {
		return ISLPrettyPrinter.asString(this, format);
	}
	
	public List<ISLConstraint> getConstraints() {
		List<ISLConstraint> res = new ArrayList<ISLConstraint>();
		for (int i = 0; i < getNbConstraints(); i++) {
			res.add(this.getConstraintAt(i));
		}
		return res;
	}

	/**
	 * XXX : not sure about order of dimensions...
	 */
	public long[][] toPolyLibArray() {
		ISLMatrix islIneq = getInequalityMatrix(ISLDimType.isl_dim_set,
				ISLDimType.isl_dim_param, ISLDimType.isl_dim_div,
				ISLDimType.isl_dim_cst);

		ISLMatrix islEq = getEqualityMatrix(ISLDimType.isl_dim_set,
				ISLDimType.isl_dim_param, ISLDimType.isl_dim_div,
				ISLDimType.isl_dim_cst);

		if (islEq.getNbCols() != islIneq.getNbCols())
			throw new RuntimeException();

		int rows = islEq.getNbRows() + islIneq.getNbRows();
		int cols = islEq.getNbCols();

		long[][] tab = new long[rows][cols + 1];

		for (int i = 0; i < islIneq.getNbRows(); i++) {
			tab[i][0] = 1;
			for (int j = 0; j < cols; j++) {
				tab[i][j + 1] = islIneq.getElementVal(i, j).asLong();
			}
		}

		for (int i = islIneq.getNbRows(); i < islIneq.getNbRows()
				+ islEq.getNbRows(); i++) {
			tab[i][0] = 0;
			for (int j = 0; j < cols; j++) {
				tab[i][j + 1] = islIneq.getElementVal(i - islIneq.getNbRows(), j).asLong();
			}

		}
		return tab;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_basic_set_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLBasicSet buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_read_from_str) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_empty 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLBasicSet buildEmpty(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_empty) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_empty(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLBasicSet buildUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_universe) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_nat_universe 
	 * 
	@take space
	 * @generated
	**/
	 public static ISLBasicSet buildNonNegUniverse(ISLSpace space) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_nat_universe) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(space);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_nat_universe(getNativePtr(space)));
			} finally {
				taken(space);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_eq_basic_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLBasicSet buildEQSet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_eq_basic_set) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_aff_eq_basic_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_le_basic_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLBasicSet buildLESet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_le_basic_set) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_aff_le_basic_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_lt_basic_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLBasicSet buildLTSet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_lt_basic_set) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_aff_lt_basic_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_ge_basic_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLBasicSet buildGESet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_ge_basic_set) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_aff_ge_basic_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_aff_gt_basic_set 
	 * 
	@take aff1 aff2
	 * @generated
	**/
	 public static ISLBasicSet buildGTSet(ISLAff aff1, ISLAff aff2) { 
		/*** PROTECTED REGION ID(static_isl_aff_gt_basic_set) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(aff1, aff2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_aff_gt_basic_set(getNativePtr(aff1), getNativePtr(aff2)));
			} finally {
				taken(aff1);
				taken(aff2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_from_constraint_matrices 
	 * 
	@take space eq ineq
	 * @generated
	**/
	 public static ISLBasicSet fromConstraintMatrices(ISLSpace space, ISLMatrix eq, ISLMatrix ineq, ISLDimType c1, ISLDimType c2, ISLDimType c3, ISLDimType c4) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_from_constraint_matrices) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(space, eq, ineq);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_from_constraint_matrices(getNativePtr(space), getNativePtr(eq), getNativePtr(ineq), c1.getValue(), c2.getValue(), c3.getValue(), c4.getValue()));
			} finally {
				taken(space);
				taken(eq);
				taken(ineq);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLBasicSet bset, int format) { 
		/*** PROTECTED REGION ID(static_isl_basic_set_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_to_string(getNativePtr(bset), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_set_from_basic_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet toSet() {
		/*** PROTECTED REGION ID(isl_set_from_basic_set) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_set_from_basic_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_union_set_from_basic_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLUnionSet toUnionSet() {
		/*** PROTECTED REGION ID(isl_union_set_from_basic_set) DISABLED START ***/
		ISLUnionSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLUnionSet.build(ISLNative.isl_union_set_from_basic_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_from_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet toBasicSetFromParamSet() {
		/*** PROTECTED REGION ID(isl_basic_set_from_params) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_from_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_list_from_basic_set 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSetList toList() {
		/*** PROTECTED REGION ID(isl_basic_set_list_from_basic_set) DISABLED START ***/
		ISLBasicSetList res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSetList.build(ISLNative.isl_basic_set_list_from_basic_set(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_basic_set_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_basic_set_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_get_space 
	 * 
	 * @generated
	**/
	public ISLSpace getSpace() {
		/*** PROTECTED REGION ID(isl_basic_set_get_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_basic_set_get_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_get_local_space 
	 * 
	 * @generated
	**/
	public ISLLocalSpace getLocalSpace() {
		/*** PROTECTED REGION ID(isl_basic_set_get_local_space) DISABLED START ***/
		ISLLocalSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLLocalSpace.build(ISLNative.isl_basic_set_get_local_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_copy 
	 * 
	 * @generated
	**/
	public ISLBasicSet copy() {
		/*** PROTECTED REGION ID(isl_basic_set_copy) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_basic_set_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_basic_set_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_add_constraint 
	 * 
	 * @take this constraint
	 * @generated
	**/
	public ISLBasicSet addConstraint(ISLConstraint constraint) {
		/*** PROTECTED REGION ID(isl_basic_set_add_constraint) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, constraint);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_add_constraint(getNativePtr(this), getNativePtr(constraint)));
			} finally {
				taken(this);
				taken(constraint);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_n_constraint 
	 * 
	 * @generated
	**/
	public int getNbConstraints() {
		/*** PROTECTED REGION ID(isl_basic_set_n_constraint) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_n_constraint(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_dim 
	 * 
	 * @generated
	**/
	public int dim(ISLDimType type) {
		/*** PROTECTED REGION ID(isl_basic_set_dim) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_dim(getNativePtr(this), type.getValue());
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_is_bounded 
	 * 
	 * @generated
	**/
	public boolean bounded() {
		/*** PROTECTED REGION ID(isl_basic_set_is_bounded) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_is_bounded(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_set_dim_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet setDimName(ISLDimType type, int pos, String s) {
		/*** PROTECTED REGION ID(isl_basic_set_set_dim_name) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_set_dim_name(getNativePtr(this), type.getValue(), pos, s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_set_tuple_id 
	 * 
	 * @take this id
	 * @generated
	**/
	public ISLBasicSet setTupleID(ISLIdentifier id) {
		/*** PROTECTED REGION ID(isl_basic_set_set_tuple_id) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, id);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_set_tuple_id(getNativePtr(this), getNativePtr(id)));
			} finally {
				taken(this);
				taken(id);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_set_tuple_name 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet setTupleName(String s) {
		/*** PROTECTED REGION ID(isl_basic_set_set_tuple_name) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_set_tuple_name(getNativePtr(this), s));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_involves_dims 
	 * 
	 * @generated
	**/
	public boolean involvesDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_involves_dims) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_involves_dims(getNativePtr(this), type.getValue(), first, n) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_get_dim_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getDimID(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_basic_set_get_dim_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_basic_set_get_dim_id(getNativePtr(this), type.getValue(), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_get_dim_name 
	 * 
	 * @generated
	**/
	public String getDimName(ISLDimType type, int pos) {
		/*** PROTECTED REGION ID(isl_basic_set_get_dim_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_get_dim_name(getNativePtr(this), type.getValue(), pos);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_get_tuple_name 
	 * 
	 * @generated
	**/
	public String getTupleName() {
		/*** PROTECTED REGION ID(isl_basic_set_get_tuple_name) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_get_tuple_name(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_remove_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet removeDivs() {
		/*** PROTECTED REGION ID(isl_basic_set_remove_divs) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_remove_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_remove_unknown_divs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet removeUnknownDivs() {
		/*** PROTECTED REGION ID(isl_basic_set_remove_unknown_divs) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_remove_unknown_divs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_remove_divs_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet removeDivsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_remove_divs_involving_dims) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_remove_divs_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_equalities_matrix 
	 * 
	 * @generated
	**/
	public ISLMatrix getEqualityMatrix(ISLDimType c1, ISLDimType c2, ISLDimType c3, ISLDimType c4) {
		/*** PROTECTED REGION ID(isl_basic_set_equalities_matrix) DISABLED START ***/
		ISLMatrix res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMatrix.build(ISLNative.isl_basic_set_equalities_matrix(getNativePtr(this), c1.getValue(), c2.getValue(), c3.getValue(), c4.getValue()));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_inequalities_matrix 
	 * 
	 * @generated
	**/
	public ISLMatrix getInequalityMatrix(ISLDimType c1, ISLDimType c2, ISLDimType c3, ISLDimType c4) {
		/*** PROTECTED REGION ID(isl_basic_set_inequalities_matrix) DISABLED START ***/
		ISLMatrix res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLMatrix.build(ISLNative.isl_basic_set_inequalities_matrix(getNativePtr(this), c1.getValue(), c2.getValue(), c3.getValue(), c4.getValue()));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_plain_is_empty 
	 * 
	 * @generated
	**/
	public boolean isPlainEmpty() {
		/*** PROTECTED REGION ID(isl_basic_set_plain_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_plain_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_is_empty 
	 * 
	 * @generated
	**/
	public boolean isEmpty() {
		/*** PROTECTED REGION ID(isl_basic_set_is_empty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_is_empty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_plain_is_universe 
	 * 
	 * @generated
	**/
	public boolean isPlainUniverse() {
		/*** PROTECTED REGION ID(isl_basic_set_plain_is_universe) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_plain_is_universe(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_is_universe 
	 * 
	 * @generated
	**/
	public boolean isUniverse() {
		/*** PROTECTED REGION ID(isl_basic_set_is_universe) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_is_universe(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_is_wrapping 
	 * 
	 * @generated
	**/
	public boolean isWrapping() {
		/*** PROTECTED REGION ID(isl_basic_set_is_wrapping) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_is_wrapping(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_sample_point 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLPoint samplePoint() {
		/*** PROTECTED REGION ID(isl_basic_set_sample_point) DISABLED START ***/
		ISLPoint res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLPoint.build(ISLNative.isl_basic_set_sample_point(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_plain_is_equal 
	 * 
	 * @generated
	**/
	public boolean isPlainEqual(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_plain_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_plain_is_equal(getNativePtr(this), getNativePtr(bset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_is_equal 
	 * 
	 * @generated
	**/
	public boolean isEqual(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_is_equal) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_is_equal(getNativePtr(this), getNativePtr(bset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_is_disjoint 
	 * 
	 * @generated
	**/
	public boolean isDisjoint(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_is_disjoint) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_is_disjoint(getNativePtr(this), getNativePtr(bset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_is_subset 
	 * 
	 * @generated
	**/
	public boolean isSubset(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_is_subset) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_basic_set_is_subset(getNativePtr(this), getNativePtr(bset2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_params 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet params() {
		/*** PROTECTED REGION ID(isl_basic_set_params) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_params(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_project_out 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet projectOut(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_project_out) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_project_out(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_eliminate 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet eliminate(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_eliminate) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_eliminate(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_fix_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet sliceFixed(ISLDimType type, int pos, int value) {
		/*** PROTECTED REGION ID(isl_basic_set_fix_si) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_fix_si(getNativePtr(this), type.getValue(), pos, value));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_fix_val 
	 * 
	 * @take this v
	 * @generated
	**/
	public ISLBasicSet sliceFixed(ISLDimType type, int pos, ISLVal v) {
		/*** PROTECTED REGION ID(isl_basic_set_fix_val) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, v);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_fix_val(getNativePtr(this), type.getValue(), pos, getNativePtr(v)));
			} finally {
				taken(this);
				taken(v);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_detect_equalities 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet detectEqualities() {
		/*** PROTECTED REGION ID(isl_basic_set_detect_equalities) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_detect_equalities(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_remove_redundancies 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet removeRedundancies() {
		/*** PROTECTED REGION ID(isl_basic_set_remove_redundancies) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_remove_redundancies(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_affine_hull 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet affineHull() {
		/*** PROTECTED REGION ID(isl_basic_set_affine_hull) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_affine_hull(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_coefficients 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet coefficients() {
		/*** PROTECTED REGION ID(isl_basic_set_coefficients) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_coefficients(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_drop_constraints_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet dropConstraintsInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_drop_constraints_involving_dims) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_drop_constraints_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_drop_constraints_not_involving_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet dropConstraintsNotInvolvingDims(ISLDimType type, int first, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_drop_constraints_not_involving_dims) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_drop_constraints_not_involving_dims(getNativePtr(this), type.getValue(), first, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_sample 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet sample() {
		/*** PROTECTED REGION ID(isl_basic_set_sample) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_sample(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_unwrap 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicMap unwrap() {
		/*** PROTECTED REGION ID(isl_basic_set_unwrap) DISABLED START ***/
		ISLBasicMap res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicMap.build(ISLNative.isl_basic_set_unwrap(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_flatten 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet flatten() {
		/*** PROTECTED REGION ID(isl_basic_set_flatten) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_flatten(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_lift 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet lift() {
		/*** PROTECTED REGION ID(isl_basic_set_lift) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_lift(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_align_params 
	 * 
	 * @take this model
	 * @generated
	**/
	public ISLBasicSet alignParams(ISLSpace model) {
		/*** PROTECTED REGION ID(isl_basic_set_align_params) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, model);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_align_params(getNativePtr(this), getNativePtr(model)));
			} finally {
				taken(this);
				taken(model);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_add_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet addDims(ISLDimType type, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_add_dims) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_add_dims(getNativePtr(this), type.getValue(), n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_insert_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet insertDims(ISLDimType type, int pos, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_insert_dims) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_insert_dims(getNativePtr(this), type.getValue(), pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_move_dims 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLBasicSet moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n) {
		/*** PROTECTED REGION ID(isl_basic_set_move_dims) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_move_dims(getNativePtr(this), dst_type.getValue(), dst_pos, src_type.getValue(), src_pos, n));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_intersect_params 
	 * 
	 * @take this bset2
	 * @generated
	**/
	public ISLBasicSet intersectParams(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_intersect_params) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, bset2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_intersect_params(getNativePtr(this), getNativePtr(bset2)));
			} finally {
				taken(this);
				taken(bset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_intersect 
	 * 
	 * @take this bset2
	 * @generated
	**/
	public ISLBasicSet intersect(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_intersect) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, bset2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_intersect(getNativePtr(this), getNativePtr(bset2)));
			} finally {
				taken(this);
				taken(bset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_union 
	 * 
	 * @take this bset2
	 * @generated
	**/
	public ISLSet union(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_union) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, bset2);
			try {
				res = ISLSet.build(ISLNative.isl_basic_set_union(getNativePtr(this), getNativePtr(bset2)));
			} finally {
				taken(this);
				taken(bset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_apply 
	 * 
	 * @take this bmap
	 * @generated
	**/
	public ISLBasicSet apply(ISLBasicMap bmap) {
		/*** PROTECTED REGION ID(isl_basic_set_apply) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, bmap);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_apply(getNativePtr(this), getNativePtr(bmap)));
			} finally {
				taken(this);
				taken(bmap);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_preimage_multi_aff 
	 * 
	 * @take this ma
	 * @generated
	**/
	public ISLBasicSet preimage(ISLMultiAff ma) {
		/*** PROTECTED REGION ID(isl_basic_set_preimage_multi_aff) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, ma);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_preimage_multi_aff(getNativePtr(this), getNativePtr(ma)));
			} finally {
				taken(this);
				taken(ma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_flat_product 
	 * 
	 * @take this bset2
	 * @generated
	**/
	public ISLBasicSet flatProduct(ISLBasicSet bset2) {
		/*** PROTECTED REGION ID(isl_basic_set_flat_product) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, bset2);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_flat_product(getNativePtr(this), getNativePtr(bset2)));
			} finally {
				taken(this);
				taken(bset2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_gist 
	 * 
	 * @take this context
	 * @generated
	**/
	public ISLBasicSet gist(ISLBasicSet context) {
		/*** PROTECTED REGION ID(isl_basic_set_gist) DISABLED START ***/
		ISLBasicSet res;
		
		synchronized(LOCK) {
			checkParameters(this, context);
			try {
				res = ISLBasicSet.build(ISLNative.isl_basic_set_gist(getNativePtr(this), getNativePtr(context)));
			} finally {
				taken(this);
				taken(context);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_partial_lexmin 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLSet partialLexMin(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_set_partial_lexmin) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLSet.build(ISLNative.isl_basic_set_partial_lexmin(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_partial_lexmax 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLSet partialLexMax(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_set_partial_lexmax) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLSet.build(ISLNative.isl_basic_set_partial_lexmax(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_lexmin 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet lexMin() {
		/*** PROTECTED REGION ID(isl_basic_set_lexmin) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_basic_set_lexmin(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_lexmax 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLSet lexMax() {
		/*** PROTECTED REGION ID(isl_basic_set_lexmax) DISABLED START ***/
		ISLSet res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLSet.build(ISLNative.isl_basic_set_lexmax(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_partial_lexmin_pw_multi_aff 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLPWMultiAff partialLexMinAsPWMultiAff(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_set_partial_lexmin_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_basic_set_partial_lexmin_pw_multi_aff(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_partial_lexmax_pw_multi_aff 
	 * 
	 * @take this dom
	 * @generated
	**/
	public ISLPWMultiAff partialLexMaxAsPWMultiAff(ISLBasicSet dom) {
		/*** PROTECTED REGION ID(isl_basic_set_partial_lexmax_pw_multi_aff) DISABLED START ***/
		ISLPWMultiAff res;
		
		synchronized(LOCK) {
			checkParameters(this, dom);
			try {
				res = ISLPWMultiAff.build(ISLNative.isl_basic_set_partial_lexmax_pw_multi_aff(getNativePtr(this), getNativePtr(dom)));
			} finally {
				taken(this);
				taken(dom);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_compute_vertices 
	 * 
	 * @generated
	**/
	public ISLVertices computeVertices() {
		/*** PROTECTED REGION ID(isl_basic_set_compute_vertices) DISABLED START ***/
		ISLVertices res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVertices.build(ISLNative.isl_basic_set_compute_vertices(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_basic_set_get_constraint_at 
	 * 
	 * @generated
	**/
	public ISLConstraint getConstraintAt(int pos) {
		/*** PROTECTED REGION ID(isl_basic_set_get_constraint_at) DISABLED START ***/
		ISLConstraint res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLConstraint.build(ISLNative.isl_basic_set_get_constraint_at(getNativePtr(this), pos));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLBasicSet_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
